#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int maxn = 4e5 + 10;

int n, a[maxn];
vector < int > adj[maxn];
void input()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
        cin >> a[i];

    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

vector < int > divisors[maxn];
void find_divisors()
{
    /// check with resize

    
    for (int i = 2; i < maxn; i ++)
        for (int j = i; j < maxn; j += i)
            divisors[j].push_back(i);
}


int used[maxn], sub[maxn], depth[maxn];
void calc(int v, int p)
{
    if (p == -1)
        depth[v] = 0;
    sub[v] = 1;
    for (int u : adj[v])
    {
        if (u == p || used[u])
            continue;

        depth[u] = depth[v] + 1;
        calc(u, v);
        sub[v] += sub[u];
    }
} 


int find_centroid(int v, int p, int sz)
{

    for (int u : adj[v])
    {
        if (u == p || used[u])
            continue;

        if (sub[u] > sz / 2)
            return find_centroid(u, v, sz);
    }

    return v;
}

const int inf = 1e9;
int far[maxn], ans;

void match(int v, int p)
{
    for (int d : divisors[a[v]])
    {
        ///cout << "match " << v << " " << p << " " << d << " " << far[d] << " " << depth[v] << endl;
        ans = max(ans, depth[v] + far[d]);
        cout << ans << endl;
    }

    for (int u : adj[v])
    {
        if (used[u] || u == p)
            continue;

        match(u, v);
    }
}

void add(int v, int p)
{
    for (int d : divisors[a[v]])
    {
        far[d] = max(far[d], depth[v]);
    }

    for (int u : adj[v])
    {
        if (used[u] || u == p)
            continue;

        add(u, v);
    }
}


void rem(int v, int p)
{
    for (int d : divisors[a[v]])
    {
        far[d] = - inf;
    }

    for (int u : adj[v])
    {
        if (used[u] || u == p)
            continue;

        rem(u, v);
    }
}

void decompose(int v)
{
    calc(v, - 1);
    int centroid = find_centroid(v, - 1, sub[v]);

    calc(centroid, - 1);
    used[centroid] = 1;
    for (int d : divisors[a[centroid]])
        far[d] = 0;
    //cout << "centroid " << v << endl;
    for (int u : adj[centroid])
    {
        //if (used[u])
          //  continue;
        match(u, centroid);
        add(u, centroid);
    }

    rem(centroid, - 1);

    for (int u : adj[centroid])
    {
        if (!used[u])
            decompose(u);
    }
}
void solve()
{
    input();
    find_divisors();
    for (int i = 0; i < maxn; i ++)
        far[i] = -inf;
    decompose(1);
    cout << ans << endl;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    speed();
    solve();
    return 0;
}

/**
7
7 6 10 21 7 11 13
1 2
1 3
2 4
2 5
3 6
3 7
*/