#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 1e6 + 10;
const int INF  = 1e9;

int n, x;
int a[MAXN];
int jump[MAXN];
llong dp[MAXN];
std::multiset <int> ms;
std::vector <int> add[MAXN];
std::vector <int> rem[MAXN];

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        add[std::max(1, i - a[i])].push_back(std::min(n, i + a[i]) + 1);
        rem[std::min(n, i + a[i]) + 1].push_back(std::min(n, i + a[i]) + 1);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (const int &val : add[i])
        {
            ms.insert(val);
        }

        for (const int &val : rem[i])
        {
            ms.erase(ms.find(val));
        }

        jump[i] = (*ms.rbegin());
    }

    llong answer = 0;
    for (int i = n ; i >= 1 ; --i)
    {
        dp[i] = dp[jump[i]] + n + 1 - jump[i];
        answer += dp[i];
    }

    std::cout << answer << '\n';
}   

void input()
{
    std::cin >> n >> x;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}