#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <random>
#include <queue>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 1e6 + 10;
const int INF  = 1e9;

int n, x;
int a[MAXN];
int jump[MAXN];
llong dp[MAXN];
std::vector <int> add[MAXN];

int perm[MAXN];
void solve()
{
    llong ans = 1e18;
    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return a[x] < a[y];
    });

    std::vector <int> v;
    for (int i = 1 ; i <= std::min(n, 50) ; ++i)
    {
        v.push_back(perm[i]);
    }

    std::mt19937 rng(69420); //std::chrono::steady_clock::time_since_epoch.count());
    for (int i = 1 ; i <= 50 ; ++i)
    {
        v.push_back(rng() % n + 1);
    }   

    v.push_back(n + 1);
    if (n <= 5000)
    {
        v.clear();
        v.resize(n + 1);
        std::iota(v.begin(), v.end(), 1);
    }

    for (const int &pos : v)
    {
        if (pos != n + 1 && a[pos] >= x)
        {
            continue;
        }

        int value = a[pos];
        a[pos] = x;
        for (int i = 1 ; i <= n ; ++i)
        {
            jump[i] = 0;
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            jump[std::max(1, i - a[i])] = std::max(jump[std::max(1, i - a[i])], std::min(n, i + a[i]) + 1);
        }

        for (int i = 2 ; i <= n ; ++i)
        {
            jump[i] = std::max(jump[i], jump[i - 1]);
        }

        llong answer = 0;
        for (int i = n ; i >= 1 ; --i)
        {
            dp[i] = dp[jump[i]] + n + 1 - jump[i];
            answer += dp[i];
        }

        ans = std::min(ans, answer);
        a[pos] = value;
    } 

    std::cout << ans << '\n';
}   

void input()
{
    std::cin >> n >> x;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}